// spica javascript libraries - cookie.js
// == written by Takuya Otani <takuya.otani@gmail.com> ===
// == Copyright (C) 2006 SimpleBoxes/SerendipityNZ Ltd. ==

// [guideline]
// -- http://serennz.sakura.ne.jp/guidelines/js_en_000.txt
// -- http://serennz.sakura.ne.jp/guidelines/js_ja_000.txt

Spica.Library.require('hash');
Spica.Cookie = function(option)
{
	this._setting = (new Spica.Hash({
		// domain: window.location.hostname,
		// path: window.location.pathname,
		name: '',
		expire: 10
	})).extend(option);
	this._cookies = {};
	this.update();
	return this;
}
Spica.Cookie.prototype = {
	update : function()
	{
		var cookies = document.cookie.split(';');
		var name = this._setting.$['name'];
		for (var i=0,n=cookies.length;i<n;i++)
		{
			cookies[i] = cookies[i].replace(/^\s*/,'');
			var value = cookies[i].split('=',2);
			if (name)
			{
				value[0] = (value[0].indexOf(name) == 0) 
					? value[0].substring(name.length + 1) 
					: '';
			}
			if (value[0])
				this._cookies[value[0]] = unescape(value[1]);
		}
	},
	get : function(name)
	{
		return this._cookies[name];
	},
	set : function(name,value)
	{
		var cookies = [];
		this._cookies[name] = value;
		if (this._setting.$['name'])
			name = [this._setting.$['name'],name].join('_');
		cookies.push([name,escape(value)].join('='));
		if (this._setting.$['expire'])
		{ // expires
			var date = new Date();
			date.setTime(date.getTime() + (this._setting.$['expire'] * 24 * 3600 * 1000));
			cookies.push(['expires',date.toGMTString()].join('='));
		}
		for (var value in this._setting.$)
		{
			if (value == 'expire' || value == 'name') continue; // already handled
			if (!this._setting.$[value]) continue; // invalid value
			cookies.push([value,this._setting.$[value]].join('='));
		}
		document.cookie = cookies.join('; ');
	}
};
